Index: /code/trunk/src/orxonox/core/OrxonoxClass.h
===================================================================
--- /code/trunk/src/orxonox/core/OrxonoxClass.h	(revision 870)
+++ /code/trunk/src/orxonox/core/OrxonoxClass.h	(revision 871)
@@ -26,5 +26,5 @@
  */
 
-/*!
+/**
     @file OrxonoxClass.h
     @brief Definition of the OrxonoxClass Class.
@@ -37,4 +37,5 @@
 #define _OrxonoxClass_H__
 
+#include <list>
 #include <string>
 
@@ -47,5 +48,5 @@
     //! The class all objects and interfaces of the game-logic (not the engine) are derived from.
     /**
-        The BaseObject and Interaces are derived with 'virtual public OrxonoxClass' from OrxonoxClass.
+        The BaseObject and Interfaces are derived with 'virtual public OrxonoxClass' from OrxonoxClass.
         OrxonoxClass is needed to create the class-hierarchy at startup and to store the Identifier and the MetaObjectList.
     */
@@ -59,5 +60,5 @@
             void setConfigValues() {};
 
-            /** @returns the Identifier of the object */
+            /** @brief Returns the Identifier of the object. @return The Identifier */
             inline Identifier* getIdentifier() const { return this->identifier_; }
 
@@ -65,99 +66,98 @@
             inline void setIdentifier(Identifier* identifier) { this->identifier_ = identifier; }
 
-            /** @returns the list of all parents of the object */
-            inline IdentifierList* getParents() const { return this->parents_; }
+            /** @brief Returns the list of all parents of the object. @return The list */
+            inline std::list<const Identifier*>* getParents() const { return this->parents_; }
 
-            /** @brief Sets the Parents of the object. Used by the RegisterObject-macro. */
-            inline void setParents(IdentifierList* parents) { this->parents_ = parents; }
+            /** @brief Creates the parents-list. */
+            inline void createParents() { this->parents_ = new std::list<const Identifier*>(); }
 
-            /** @returns the MetaObjectList of the object, containing a link to all ObjectLists and ObjectListElements the object is registered in. */
+            /** @brief Returns the MetaObjectList of the object, containing a link to all ObjectLists and ObjectListElements the object is registered in. @return The list */
             inline MetaObjectList& getMetaList() { return this->metaList_; }
 
 
-            /** @returns true if the objects class is of the given type or a derivative. */
+            /** @brief Returns true if the objects class is of the given type or a derivative. */
             inline bool isA(const Identifier* identifier)
                 { return this->getIdentifier()->isA(identifier); }
-            /** @returns true if the objects class is exactly of the given type. */
-            inline bool isDirectlyA(const Identifier* identifier)
-                { return this->getIdentifier()->isDirectlyA(identifier); }
-            /** @returns true if the objects class is a child of the given type. */
+            /** @brief Returns true if the objects class is exactly of the given type. */
+            inline bool isExactlyA(const Identifier* identifier)
+                { return this->getIdentifier()->isExactlyA(identifier); }
+            /** @brief Returns true if the objects class is a child of the given type. */
             inline bool isChildOf(const Identifier* identifier)
                 { return this->getIdentifier()->isChildOf(identifier); }
-            /** @returns true if the objects class is a parent of the given type. */
+            /** @brief Returns true if the objects class is a direct child of the given type. */
+            inline bool isDirectChildOf(const Identifier* identifier)
+                { return this->getIdentifier()->isDirectChildOf(identifier); }
+            /** @brief Returns true if the objects class is a parent of the given type. */
             inline bool isParentOf(const Identifier* identifier)
                 { return this->getIdentifier()->isParentOf(identifier); }
+            /** @brief Returns true if the objects class is a direct parent of the given type. */
+            inline bool isDirectParentOf(const Identifier* identifier)
+                { return this->getIdentifier()->isDirectParentOf(identifier); }
 
 
-            /** @returns true if the objects class is of the given type or a derivative. */
+            /** @brief Returns true if the objects class is of the given type or a derivative. */
             inline bool isA(const SubclassIdentifier<class B>* identifier)
                 { return this->getIdentifier()->isA(identifier->getIdentifier()); }
-            /** @returns true if the objects class is exactly of the given type. */
-            inline bool isDirectlyA(const SubclassIdentifier<class B>* identifier)
-                { return this->getIdentifier()->isDirectlyA(identifier->getIdentifier()); }
-            /** @returns true if the objects class is a child of the given type. */
+            /** @brief Returns true if the objects class is exactly of the given type. */
+            inline bool isExactlyA(const SubclassIdentifier<class B>* identifier)
+                { return this->getIdentifier()->isExactlyA(identifier->getIdentifier()); }
+            /** @brief Returns true if the objects class is a child of the given type. */
             inline bool isChildOf(const SubclassIdentifier<class B>* identifier)
                 { return this->getIdentifier()->isChildOf(identifier->getIdentifier()); }
-            /** @returns true if the objects class is a parent of the given type. */
+            /** @brief Returns true if the objects class is a direct child of the given type. */
+            inline bool isDirectChildOf(const SubclassIdentifier<class B>* identifier)
+                { return this->getIdentifier()->isDirectChildOf(identifier->getIdentifier()); }
+            /** @brief Returns true if the objects class is a parent of the given type. */
             inline bool isParentOf(const SubclassIdentifier<class B>* identifier)
                 { return this->getIdentifier()->isParentOf(identifier->getIdentifier()); }
+            /** @brief Returns true if the objects class is a direct parent of the given type. */
+            inline bool isDirectParentOf(const SubclassIdentifier<class B>* identifier)
+                { return this->getIdentifier()->isDirectParentOf(identifier->getIdentifier()); }
 
 
-            /** @returns true if the objects class is of the given type or a derivative. */
+            /** @brief Returns true if the objects class is of the given type or a derivative. */
             inline bool isA(const SubclassIdentifier<class B> identifier)
                 { return this->getIdentifier()->isA(identifier.getIdentifier()); }
-            /** @returns true if the objects class is exactly of the given type. */
-            inline bool isDirectlyA(const SubclassIdentifier<class B> identifier)
-                { return this->getIdentifier()->isDirectlyA(identifier.getIdentifier()); }
-            /** @returns true if the objects class is a child of the given type. */
+            /** @brief Returns true if the objects class is exactly of the given type. */
+            inline bool isExactlyA(const SubclassIdentifier<class B> identifier)
+                { return this->getIdentifier()->isExactlyA(identifier.getIdentifier()); }
+            /** @brief Returns true if the objects class is a child of the given type. */
             inline bool isChildOf(const SubclassIdentifier<class B> identifier)
                 { return this->getIdentifier()->isChildOf(identifier.getIdentifier()); }
-            /** @returns true if the objects class is a parent of the given type. */
+            /** @brief Returns true if the objects class is a direct child of the given type. */
+            inline bool isDirectChildOf(const SubclassIdentifier<class B> identifier)
+                { return this->getIdentifier()->isDirectChildOf(identifier.getIdentifier()); }
+            /** @brief Returns true if the objects class is a parent of the given type. */
             inline bool isParentOf(const SubclassIdentifier<class B> identifier)
                 { return this->getIdentifier()->isParentOf(identifier.getIdentifier()); }
+            /** @brief Returns true if the objects class is a direct parent of the given type. */
+            inline bool isDirectParentOf(const SubclassIdentifier<class B> identifier)
+                { return this->getIdentifier()->isDirectParentOf(identifier.getIdentifier()); }
 
 
-            /** @returns true if the objects class is of the given type or a derivative. */
+            /** @brief Returns true if the objects class is of the given type or a derivative. */
             inline bool isA(const OrxonoxClass* object)
                 { return this->getIdentifier()->isA(object->getIdentifier()); }
-            /** @returns true if the objects class is exactly of the given type. */
-            inline bool isDirectlyA(const OrxonoxClass* object)
-                { return this->getIdentifier()->isDirectlyA(object->getIdentifier()); }
-            /** @returns true if the objects class is a child of the given type. */
+            /** @brief Returns true if the objects class is exactly of the given type. */
+            inline bool isExactlyA(const OrxonoxClass* object)
+                { return this->getIdentifier()->isExactlyA(object->getIdentifier()); }
+            /** @brief Returns true if the objects class is a child of the given type. */
             inline bool isChildOf(const OrxonoxClass* object)
                 { return this->getIdentifier()->isChildOf(object->getIdentifier()); }
-            /** @returns true if the objects class is a parent of the given type. */
+            /** @brief Returns true if the objects class is a direct child of the given type. */
+            inline bool isDirectChildOf(const OrxonoxClass* object)
+                { return this->getIdentifier()->isDirectChildOf(object->getIdentifier()); }
+            /** @brief Returns true if the objects class is a parent of the given type. */
             inline bool isParentOf(const OrxonoxClass* object)
                 { return this->getIdentifier()->isParentOf(object->getIdentifier()); }
-
-
-            /** @brief Sets the name of the object. @param name The name */
-            inline virtual void setName(const std::string& name) { this->name_ = name; }
-
-            /** @returns the name of the object. */
-            inline const std::string& getName() const { return this->name_; }
-
-            /** @brief Sets the state of the objects activity. @param bActive True = active */
-            inline virtual void setActive(bool bActive) { this->bActive_ = bActive; }
-
-            /** @returns the state of the objects activity. */
-            inline const bool isActive() const { return this->bActive_; }
-
-            /** @brief Sets the state of the objects visibility. @param bVisible True = visible */
-            inline virtual void setVisible(bool bVisible) { this->bVisible_ = bVisible; }
-
-            /** @returns the state of the objects visibility. */
-            inline const bool isVisible() const { return this->bVisible_; }
+            /** @brief Returns true if the objects class is a direct child of the given type. */
+            inline bool isDirectParentOf(const OrxonoxClass* object)
+                { return this->getIdentifier()->isDirectParentOf(object->getIdentifier()); }
 
         private:
-            Identifier* identifier_;        //!< The Identifier of the object
-            IdentifierList* parents_;       //!< List of all parents of the object
-            MetaObjectList metaList_;       //!< MetaObjectList, containing all ObjectLists and ObjectListElements the object is registered in
-
-            std::string name_;              //!< The name of the object
-            bool bActive_;                  //!< True = the object is active
-            bool bVisible_;                 //!< True = the object is visible
+            Identifier* identifier_;                    //!< The Identifier of the object
+            std::list<const Identifier*>* parents_;     //!< List of all parents of the object
+            MetaObjectList metaList_;                   //!< MetaObjectList, containing all ObjectLists and ObjectListElements the object is registered in
     };
-    template class _CoreExport orxonox::ClassIdentifier<OrxonoxClass>;
-    template class _CoreExport orxonox::ObjectList<OrxonoxClass>;
 }
 
Index: /code/trunk/src/orxonox/core/OutputHandler.cc
===================================================================
--- /code/trunk/src/orxonox/core/OutputHandler.cc	(revision 870)
+++ /code/trunk/src/orxonox/core/OutputHandler.cc	(revision 871)
@@ -25,4 +25,9 @@
  *
  */
+
+/**
+    @file OutputHandler.cc
+    @brief Implementation of the OutputHandler class.
+*/
 
 #include "DebugLevel.h"
@@ -53,5 +58,6 @@
 
     /**
-        @returns a reference to the only existing instance of the OutputHandler class.
+        @brief Returns a reference to the only existing instance of the OutputHandler class.
+        @return The instance
     */
     OutputHandler& OutputHandler::getOutStream()
Index: /code/trunk/src/orxonox/core/OutputHandler.h
===================================================================
--- /code/trunk/src/orxonox/core/OutputHandler.h	(revision 870)
+++ /code/trunk/src/orxonox/core/OutputHandler.h	(revision 871)
@@ -26,5 +26,5 @@
  */
 
-/*!
+/**
     @file OutputHandler.h
     @brief Definition of the OutputHandler class.
@@ -59,5 +59,5 @@
             static OutputHandler& getOutStream();
 
-            /** @returns a reference to the logfile. */
+            /** @brief Returns a reference to the logfile. @return The logfile */
             inline std::ofstream& getLogfile()
                 { return this->logfile_; }
@@ -67,5 +67,5 @@
                 { this->outputLevel_ = level; return *this; }
 
-            /** @returns the level of the incoming output. */
+            /** @brief Returns the level of the incoming output. @return The level */
             inline int getOutputLevel() const
                 { return this->outputLevel_; }
Index: /code/trunk/src/orxonox/core/SignalHandler.cc
===================================================================
--- /code/trunk/src/orxonox/core/SignalHandler.cc	(revision 870)
+++ /code/trunk/src/orxonox/core/SignalHandler.cc	(revision 871)
@@ -25,4 +25,9 @@
  *
  */
+
+/**
+    @file SignalHandler.cc
+    @brief Implementation of the SignalHandler class.
+*/
 
 #include <assert.h>
Index: /code/trunk/src/orxonox/core/SignalHandler.h
===================================================================
--- /code/trunk/src/orxonox/core/SignalHandler.h	(revision 870)
+++ /code/trunk/src/orxonox/core/SignalHandler.h	(revision 871)
@@ -26,7 +26,8 @@
  */
 
-/*!
- * @file SignalHandler.h
- */
+/**
+    @file SignalHandler.h
+    @brief Definition of the SignalHandler class.
+*/
 
 #ifndef _SignalHandler_H__
Index: /code/trunk/src/orxonox/core/XMLPort.cc
===================================================================
--- /code/trunk/src/orxonox/core/XMLPort.cc	(revision 871)
+++ /code/trunk/src/orxonox/core/XMLPort.cc	(revision 871)
@@ -0,0 +1,90 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "XMLPort.h"
+#include "Language.h"
+#include "Loader.h"
+
+namespace orxonox
+{
+    // ###############################
+    // ###  XMLPortParamContainer  ###
+    // ###############################
+    XMLPortParamContainer::XMLPortParamContainer()
+    {
+        this->bAddedDescription_ = false;
+        this->bAddedDefaultValues_ = false;
+    }
+
+    XMLPortParamContainer& XMLPortParamContainer::description(const std::string description)
+    {
+        if (!this->bAddedDescription_)
+        {
+            this->description_ = std::string("XMLPortParamContainer::" + this->classname_ + "::" + this->paramname_);
+            AddLanguageEntry(this->description_, description);
+            this->bAddedDescription_ = true;
+        }
+
+        return (*this);
+    }
+
+    const std::string& XMLPortParamContainer::getDescription()
+    {
+        return GetLocalisation(this->description_);
+    }
+
+
+    // ################################
+    // ###  XMLPortObjectContainer  ###
+    // ################################
+    XMLPortObjectContainer::XMLPortObjectContainer()
+    {
+        this->bAddedDescription_ = false;
+    }
+
+    XMLPortObjectContainer& XMLPortObjectContainer::description(const std::string description)
+    {
+        if (!this->bAddedDescription_)
+        {
+            this->description_ = std::string("XMLPortObjectContainer::" + this->classname_ + "::" + this->sectionname_);
+            AddLanguageEntry(this->description_, description);
+            this->bAddedDescription_ = true;
+        }
+
+        return (*this);
+    }
+
+    const std::string& XMLPortObjectContainer::getDescription()
+    {
+        return GetLocalisation(this->description_);
+    }
+
+    bool XMLPortObjectContainer::identifierIsIncludedInLoaderMask(const Identifier* identifier)
+    {
+        return Loader::currentMask_s.isIncluded(identifier);
+    }
+}
